% Christian Walther, diploma thesis 2005

Rs = 0:.25:4;
ds = 0:.25:2.5;

try
    load('transmission');
end
if (~exist('ps', 'var') || any(size(ps) ~= [length(Rs), length(ds)]))
    ps = transmission(Rs, ds);
    save('transmission', 'ps');
end

figure(1);
surf(ds, Rs, ps);
view(-60, 30);
xlabel('d');
ylabel('R');
zlabel('P');
title({'Directing a gaussian beam of radius 1 onto a circular aperture of radius R,', 'off-center by a distance d, what fraction P of the power is transmitted?'});

figure(2);
surf(ds, Rs, max(0, 1-ps));
hold on;
contour3(ds, Rs, max(0, 1-ps), kron(10.^-(1:13), [5, 2, 1]), '-k');
hold off;
set(gca, 'Zscale', 'log');
view(-60, 30);
xlabel('d');
ylabel('R');
zlabel('1 - P');
title({'Directing a gaussian beam of radius 1 onto a circular aperture of radius R,', 'off-center by a distance d, what fraction 1 - P of the power is lost?'});

figure(3);
contour(ds, Rs, log(1-ps)/log(10), kron(-(1:13), [1, 1]) + kron(ones(1, 13), log([2, 5])/log(10)), 'Color', [.8, .8, .8], 'LineWidth', 0.2835);
hold on;
contour(ds, Rs, log(1-ps)/log(10), -(1:13), '-k', 'ShowText', 'on', 'LineWidth', 0.8504);
hold off;
xlabel('d');
ylabel('R');
text(.65*ds(end), .2*Rs(end), 'log_{10}(1 - P)');
grid on;
title({'Directing a gaussian beam of radius 1 onto a circular aperture of radius R,', 'off-center by a distance d, what fraction 1 - P of the power is lost?'});
