% Christian Walther, diploma thesis 2005

function ps = transmission(Rs, ds)

    ts = zeros(length(Rs), length(ds));
    
    tic;
    t = 0;

    for i = 1:length(Rs)
        for j = 1:length(ds)
            fprintf('R = %4.2f, d = %4.2f...', Rs(i), ds(j));
            ps(i, j) = singletrans(Rs(i), ds(j));
            nt = toc;
            ts(i, j) = nt - t;
            fprintf(' %6.2f secs (%6.1f total)\n', nt - t, nt);
            t = nt;
        end
    end
    
    % graph calculation time
    %figure(5);
    %surf(ds, Rs, ts);

    function p = singletrans(R, d)

        if (R == inf && d == inf)
            p = nan;
        elseif (R == inf)
            p = 1;
        elseif (d == inf)
            p = 0;
        elseif (R == 0)
            p = 0;
        elseif (d == 0)
            p = 1 - exp(-2*R^2);
        else
            p = 2/pi*exp(-2*d^2)*dblquad(@integrand, 0, R, 0, 2*pi, 1e-1*max(exp(-2*R^2), (1 - erf(sqrt(2)*(R - d)))/2), @quadl);
        end
        
        function g = integrand(r, phi)
            g = r.*exp(-2*(r.^2 - 2*r*d*cos(phi)));
        end

    end

end