% Lens design

% Christian Walther, diploma thesis 2005

function r = curv(z, j)

wp = evalin('base', 'wp');
lp = evalin('base', 'lp');
dw = evalin('base', 'dw');
leff = evalin('base', 'cwldleff');

[lp, no] = sort(lp);
no = [1, no+1];
wp = wp(no,:);
dw = dw(no,:);

for k = 1:length(z)

    i = 1;
    while (i <= length(lp) && z(k) > lp(i))
        i = i + 1;
    end
    
    r(k) = (z(k) - wp(i, j)) + (pi*(dw(i, j)/2)^2/leff(j))^2/(z(k) - wp(i, j));
    
end