% Lens design

% Christian Walther, diploma thesis 2005


function varargout = design(varargin)
% DESIGN M-file for design.fig
%      DESIGN, by itself, creates a new DESIGN or raises the existing
%      singleton*.
%
%      H = DESIGN returns the handle to a new DESIGN or the handle to
%      the existing singleton*.
%
%      DESIGN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DESIGN.M with the given input arguments.
%
%      DESIGN('Property','Value',...) creates a new DESIGN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before design_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to design_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help design

% Last Modified by GUIDE v2.5 21-Jan-2005 10:08:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @design_OpeningFcn, ...
                   'gui_OutputFcn',  @design_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before design is made visible.
function design_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to design (see VARARGIN)

% Choose default command line output for design
handles.output = hObject;

handles.lenses = struct('f', {}, 'z', {});
handles.beams = struct('name', {}, 'lambda', {}, 'm2', {}, 'diam', {}, 'r', {}, 'z', {});
handles.lensbeams = [];

assignin('base', 'cwldfigure', hObject);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes design wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = design_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox_lenses.
function listbox_lenses_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_lenses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_lenses contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_lenses
updateLensesUI(handles);


% --- Executes on button press in pushbutton_lens_add.
function pushbutton_lens_add_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_lens_add (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (length(handles.lenses) == 0)
    i = 0;
else
    i = get(handles.listbox_lenses, 'Value');
end
handles.lenses = [handles.lenses(1:i), struct('f', '', 'z', '0'), handles.lenses(i+1:end)];
set(handles.listbox_lenses, 'Value', i+1);
handles.lensbeams = [handles.lensbeams(1:i,:); ones(1, length(handles.beams)); handles.lensbeams(i+1:end,:)];
guidata(hObject, handles);
updateLensesUI(handles);


% --- Executes on button press in pushbutton_lens_remove.
function pushbutton_lens_remove_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_lens_remove (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (length(handles.lenses) > 0)
    i = get(handles.listbox_lenses, 'Value');
    handles.lenses = [handles.lenses(1:i-1), handles.lenses(i+1:end)];
    set(handles.listbox_lenses, 'Value', max(i-1, 1));
    handles.lensbeams = [handles.lensbeams(1:i-1,:); handles.lensbeams(i+1:end,:)];
    guidata(hObject, handles);
    updateLensesUI(handles);
end


% --- Executes on button press in pushbutton_lens_up.
function pushbutton_lens_up_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_lens_up (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (length(handles.lenses) > 0)
    i = get(handles.listbox_lenses, 'Value');
    if (i > 1)
        handles.lenses = [handles.lenses(1:i-2), handles.lenses(i), handles.lenses(i-1), handles.lenses(i+1:end)];
        set(handles.listbox_lenses, 'Value', i-1);
        handles.lensbeams = [handles.lensbeams(1:i-2,:); handles.lensbeams(i,:); handles.lensbeams(i-1,:); handles.lensbeams(i+1:end,:)];
        guidata(hObject, handles);
        updateLensesUI(handles);
    end
end


% --- Executes on button press in pushbutton_lens_down.
function pushbutton_lens_down_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_lens_down (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (length(handles.lenses) > 0)
    i = get(handles.listbox_lenses, 'Value');
    if (i < length(handles.lenses))
        handles.lenses = [handles.lenses(1:i-1), handles.lenses(i+1), handles.lenses(i), handles.lenses(i+2:end)];
        set(handles.listbox_lenses, 'Value', i+1);
        handles.lensbeams = [handles.lensbeams(1:i-1,:); handles.lensbeams(i+1,:); handles.lensbeams(i,:); handles.lensbeams(i+2:end,:)];
        guidata(hObject, handles);
        updateLensesUI(handles);
    end
end


function edit_lens_f_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lens_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lens_f as text
%        str2double(get(hObject,'String')) returns contents of edit_lens_f as a double
if (length(handles.lenses) > 0)
    i = get(handles.listbox_lenses, 'Value');
    handles.lenses(i).f = get(hObject, 'String');
    guidata(hObject, handles);
    updateLensesUI(handles);
end


% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
lenses = handles.lenses;
beams = handles.beams;
lensbeams = handles.lensbeams;
zmin = get(handles.edit_zmin, 'String');
zmax = get(handles.edit_zmax, 'String');
dmax = get(handles.edit_dmax, 'String');
figure = get(handles.edit_figure, 'String');
keep = get(handles.checkbox_keep, 'Value');
collect1 = get(handles.checkbox_collect1, 'Value');
collect2 = get(handles.checkbox_collect2, 'Value');
collect1_horizontal = get(handles.edit_collect1_horizontal, 'String');
collect2_horizontal = get(handles.edit_collect2_horizontal, 'String');
collect1_vertical = get(handles.edit_collect1_vertical, 'String');
collect2_vertical = get(handles.edit_collect2_vertical, 'String');
collect_figure = get(handles.edit_collect_figure, 'String');
collect_separate = get(handles.checkbox_collect_separate, 'Value');
save(get(handles.edit_filename, 'String'), 'lenses', 'beams', 'lensbeams', 'zmin', 'zmax', 'dmax', ...
    'figure', 'keep', 'collect1', 'collect2', 'collect1_horizontal', ...
    'collect2_horizontal', 'collect1_vertical', 'collect2_vertical', ...
    'collect_figure', 'collect_separate');


% --- Executes on button press in pushbutton_load.
function pushbutton_load_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load(get(handles.edit_filename, 'String'), 'lenses', 'beams', 'lensbeams', 'zmin', 'zmax', 'dmax', ...
    'figure', 'keep', 'collect1', 'collect2', 'collect1_horizontal', ...
    'collect2_horizontal', 'collect1_vertical', 'collect2_vertical', ...
    'collect_figure', 'collect_separate');
handles.lenses = lenses;
handles.beams = beams;
try %backwards compatibility
    handles.lensbeams = lensbeams;
catch
    handles.lensbeams = ones(length(lenses), length(beams));
end
set(handles.edit_zmin, 'String', zmin);
set(handles.edit_zmax, 'String', zmax);
try %backwards compatibility
    set(handles.edit_dmax, 'String', dmax);
catch
    set(handles.edit_dmax, 'String', 'inf');
end
set(handles.edit_figure, 'String', figure);
set(handles.checkbox_keep, 'Value', keep);
set(handles.checkbox_collect1, 'Value', collect1);
set(handles.checkbox_collect2, 'Value', collect2);
set(handles.edit_collect1_horizontal, 'String', collect1_horizontal);
set(handles.edit_collect2_horizontal, 'String', collect2_horizontal);
set(handles.edit_collect1_vertical, 'String', collect1_vertical);
set(handles.edit_collect2_vertical, 'String', collect2_vertical);
set(handles.edit_collect_figure, 'String', collect_figure);
set(handles.checkbox_collect_separate, 'Value', collect_separate);
guidata(hObject, handles);
updateLensesUI(handles);
updateBeamsUI(handles);


function edit_filename_Callback(hObject, eventdata, handles)
% hObject    handle to edit_filename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_filename as text
%        str2double(get(hObject,'String')) returns contents of edit_filename as a double


% --- Executes on button press in pushbutton_compute.
function pushbutton_compute_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_compute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
compute();


% --- Executes on selection change in listbox_beams.
function listbox_beams_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_beams (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_beams contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_beams
updateBeamsUI(handles);


% --- Executes on button press in pushbutton_beam_add.
function pushbutton_beam_add_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_beam_add (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (length(handles.beams) == 0)
    handles.beams = struct('name', 'x', 'lambda', '', 'm2', '1.0', 'diam', '', 'r', 'inf', 'z', '0');
    i = 0;
else
    i = get(handles.listbox_beams, 'Value');
    handles.beams = [handles.beams(1:i), handles.beams(i), handles.beams(i+1:end)];
end
set(handles.listbox_beams, 'Value', i+1);
handles.lensbeams = [handles.lensbeams(:,1:i), ones(length(handles.lenses), 1), handles.lensbeams(:,i+1:end)];
guidata(hObject, handles);
updateBeamsUI(handles);



% --- Executes on button press in pushbutton_beam_remove.
function pushbutton_beam_remove_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_beam_remove (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams = [handles.beams(1:i-1), handles.beams(i+1:end)];
    set(handles.listbox_beams, 'Value', max(i-1, 1));
    handles.lensbeams = [handles.lensbeams(:,1:i-1), handles.lensbeams(:,i+1:end)];
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


function edit_beam_name_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beam_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beam_name as text
%        str2double(get(hObject,'String')) returns contents of edit_beam_name as a double
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams(i).name = get(hObject, 'String');
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


function edit_beam_lambda_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beam_lambda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beam_lambda as text
%        str2double(get(hObject,'String')) returns contents of edit_beam_lambda as a double
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams(i).lambda = get(hObject, 'String');
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


function edit_beam_diam_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beam_diam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beam_diam as text
%        str2double(get(hObject,'String')) returns contents of
%        edit_beam_diam as a double
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams(i).diam = get(hObject, 'String');
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


function edit_beam_r_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beam_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beam_r as text
%        str2double(get(hObject,'String')) returns contents of edit_beam_r as a double
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams(i).r = get(hObject, 'String');
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


function edit_beam_z_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beam_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beam_z as text
%        str2double(get(hObject,'String')) returns contents of edit_beam_z as a double
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams(i).z = get(hObject, 'String');
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


function edit_zmin_Callback(hObject, eventdata, handles)
% hObject    handle to edit_zmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_zmin as text
%        str2double(get(hObject,'String')) returns contents of edit_zmin as a double


function edit_zmax_Callback(hObject, eventdata, handles)
% hObject    handle to edit_zmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_zmax as text
%        str2double(get(hObject,'String')) returns contents of edit_zmax as a double


function edit_figure_Callback(hObject, eventdata, handles)
% hObject    handle to edit_figure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_figure as text
%        str2double(get(hObject,'String')) returns contents of edit_figure as a double


% --- Executes on button press in checkbox_keep.
function checkbox_keep_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_keep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_keep


% --- Executes on button press in checkbox_collect1.
function checkbox_collect1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_collect1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_collect1



function edit_collect1_horizontal_Callback(hObject, eventdata, handles)
% hObject    handle to edit_collect1_horizontal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_collect1_horizontal as text
%        str2double(get(hObject,'String')) returns contents of edit_collect1_horizontal as a double


function edit_collect1_vertical_Callback(hObject, eventdata, handles)
% hObject    handle to edit_collect1_vertical (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_collect1_vertical as text
%        str2double(get(hObject,'String')) returns contents of edit_collect1_vertical as a double


function edit_collect_figure_Callback(hObject, eventdata, handles)
% hObject    handle to edit_collect_figure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_collect_figure as text
%        str2double(get(hObject,'String')) returns contents of edit_collect_figure as a double


% --- Executes on button press in checkbox_collect2.
function checkbox_collect2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_collect2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_collect2



function edit_collect2_horizontal_Callback(hObject, eventdata, handles)
% hObject    handle to edit_collect2_horizontal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_collect2_horizontal as text
%        str2double(get(hObject,'String')) returns contents of edit_collect2_horizontal as a double


function edit_collect2_vertical_Callback(hObject, eventdata, handles)
% hObject    handle to edit_collect2_vertical (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_collect2_vertical as text
%        str2double(get(hObject,'String')) returns contents of edit_collect2_vertical as a double


function edit_lens_z_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lens_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lens_z as text
%        str2double(get(hObject,'String')) returns contents of edit_lens_z as a double
if (length(handles.lenses) > 0)
    i = get(handles.listbox_lenses, 'Value');
    handles.lenses(i).z = get(hObject, 'String');
    guidata(hObject, handles);
    updateLensesUI(handles);
end


function edit_beam_m2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beam_m2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_beam_m2 as text
%        str2double(get(hObject,'String')) returns contents of edit_beam_m2 as a double
if (length(handles.beams) > 0)
    i = get(handles.listbox_beams, 'Value');
    handles.beams(i).m2 = get(hObject, 'String');
    guidata(hObject, handles);
    updateBeamsUI(handles);
end


% --- Executes on button press in checkbox_collect_separate.
function checkbox_collect_separate_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_collect_separate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_collect_separate











function updateLensesUI(handles)
if (length(handles.lenses) == 0)
    set(handles.listbox_lenses, 'String', '');
else
    str = [];
    for i = 1:length(handles.lenses)
        lbs = '';
        for j = 1:length(handles.beams)
            if (handles.lensbeams(i, j))
                lbs = [lbs, int2str(j)];
            else
                lbs = [lbs, '-'];
            end
        end
        str{end+1} = sprintf('%d (%s): f = %s, z = %s', i, lbs, handles.lenses(i).f, handles.lenses(i).z);
    end
    set(handles.listbox_lenses, 'String', str);
    
    i = get(handles.listbox_lenses, 'Value');
    set(handles.edit_lens_f, 'String', handles.lenses(i).f);
    set(handles.edit_lens_z, 'String', handles.lenses(i).z);
    set(handles.listbox_lensbeams, 'Value', find(handles.lensbeams(i,:)));
end


function updateBeamsUI(handles)
if (length(handles.beams) == 0)
    set(handles.listbox_beams, 'String', '');
else
    str = [];
    for i = 1:length(handles.beams)
        str{end+1} = sprintf('%d. %s: %s, %s, (%s, %s) @ %s', i, handles.beams(i).name, handles.beams(i).lambda, handles.beams(i).m2, handles.beams(i).diam, handles.beams(i).r, handles.beams(i).z);
    end
    set(handles.listbox_beams, 'String', str);
    
    str = [];
    for i = 1:length(handles.beams)
        str{end+1} = sprintf('%d. %s', i, handles.beams(i).name);
    end
    set(handles.listbox_lensbeams, 'String', str);
    
    i = get(handles.listbox_beams, 'Value');
    set(handles.edit_beam_name, 'String', handles.beams(i).name);
    set(handles.edit_beam_lambda, 'String', handles.beams(i).lambda);
    set(handles.edit_beam_m2, 'String', handles.beams(i).m2);
    set(handles.edit_beam_diam, 'String', handles.beams(i).diam);
    set(handles.edit_beam_r, 'String', handles.beams(i).r);
    set(handles.edit_beam_z, 'String', handles.beams(i).z);
end
updateLensesUI(handles);


% --- Executes on selection change in listbox_lensbeams.
function listbox_lensbeams_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_lensbeams (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_lensbeams contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_lensbeams
if (length(handles.lenses) > 0)
    i = get(handles.listbox_lenses, 'Value');
    handles.lensbeams(i,:) = 0;
    handles.lensbeams(i,get(hObject,'Value')) = 1;
    guidata(hObject, handles);
    updateLensesUI(handles);
end



function edit_dmax_Callback(hObject, eventdata, handles)
% hObject    handle to edit_dmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_dmax as text
%        str2double(get(hObject,'String')) returns contents of edit_dmax as
%        a double


% --- Executes on button press in pushbutton_clear.
function pushbutton_clear_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_clear (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cleardata();


