% Lens design

% Christian Walther, diploma thesis 2005

function d = diam(z, j)

wp = evalin('base', 'wp');
lp = evalin('base', 'lp');
dw = evalin('base', 'dw');
leff = evalin('base', 'cwldleff');

[lp, no] = sort(lp);
no = [1, no+1];
wp = wp(no,:);
dw = dw(no,:);

for k = 1:length(z)

    i = 1;
    while (i <= length(lp) && z(k) > lp(i))
        i = i + 1;
    end

    d(k) = dw(i, j)*sqrt(1 + ((z(k) - wp(i, j))/(pi*(dw(i, j)/2)^2/leff(j)))^2);
    
end