#pragma rtGlobals=1		// Use modern global access method.

// Christian Walther, diploma thesis 2005

// requires "Load_Fsat_stats_fix_smooth" and "FsatFitFunctions II" procedures

Menu "Macros"
	"Load Processed Data and Fit Fsat", LoadAndFitFsat()
End

function LoadAndFitFsat()
	String nameprefix
	String filename
	Variable i = 0
	NewPath/Q/O/M="Select folder with sample files:" measurePath
	Prompt nameprefix, "Load all files whose name starts with"
	DoPrompt "Load Files", nameprefix
	if (V_flag)
		return 0
	endif
	make /O /T /N=0 sample_fileName
	do
		filename = IndexedFile(measurePath, i, "????")
		if (cmpstr(filename[0, strlen(nameprefix)-1], nameprefix) == 0)
			InsertPoints 0, 1, sample_fileName
			sample_fileName[0] = filename
		endif
		i += 1
	while (strlen(filename) != 0)
	
	wave/T samples=sample_fileName
	make /O /N=(numPnts(samples)) sample_time
	wave sample_time=sample_time

	Duplicate/O sample_time,Fsat
	Fsat=NaN
	Duplicate/O Fsat, Rlin,Rns,Rmax,dR,dRns,dRmax,eFsat,eRlin,eRns,edR,edRns
	Duplicate/O Fsat, Fsat0,eFsat0,Rlin0,eRlin0,Rns0,eRns0, Beta0,eBeta0
	Duplicate/O Fsat, FsatInf,eFsatInf,RlinInf,eRlinInf,RnsInf,eRnsInf,betaInf,eBetaInf

	Do
		LoadWave/Q/G/N=HRdata/P=measurePath samples[i]
		Duplicate/O HRData0, $("F_"+samples[i])
		Duplicate/O HRData1, $("R_"+samples[i])

		wave flu=$("F_"+samples[i])
		wave refl=$("R_"+samples[i])
		
		refl*=100
		flu *= 100
		
		Display/W=(450+10*i,100+15*I,950+10*i,400+15*i) refl vs flu as samples[i]
		ModifyGraph log(bottom)=1,tick=2,mirror=1
		ModifyGraph mode=2,lsize=2
		SetAxis/A/N=1	
		Label left "Reflectivity (%)"
		Label bottom "Fluence (J/cm2)"
		TextBox/N=Leg/M/A=LT/X=0/Y=0 samples[i]
		Fit(i, Fsat,Rlin,Rns,Rmax,dR,dRns,dRmax,eFsat,eRlin,eRns,edR,edRns,Fsat0,eFsat0,Rlin0,eRlin0,Rns0,eRns0,beta0,eBeta0,FsatInf,eFsatInf,RlinInf,eRlinInf,RnsInf,eRnsInf,betaInf,eBetaInf)
		i+=1
	While (i<numPnts(samples))
	KillWaves/Z HRdata0,HRdata1,HRdata2,HRdata3,HRdata4
End