% Christian Walther, diploma thesis 2005

Ws = [.025, .05, .1:.15:1.3, 1.5:.25:2, 2.5:.5:6];
Ds = [.5*10.^(-3:.5:-1), .1:.05:.85, .9:.025:1];

[Dm, Wm] = meshgrid(Ds, Ws);

try
    load('loss');
end
if (~exist('ls', 'var') || any(size(ls) ~= [length(Ws), length(Ds)]))
    ls = loss(Ws, Ds);
    save('loss', 'ls');
end

figure(21);
%figure(20); subplot(2, 2, 1);
surf(Ds, Ws, ls);
view(-50, 30);
xlabel('D');
ylabel('W');
zlabel('L');
title({'Directing a Gaussian beam of radius W onto a circular aperture of radius 1, what fraction', 'L = 1 - P_d/P_c of the transmitted power is lost if the beam is displaced from the center by D?', '(linear scale)'});

figure(22);
%subplot(2, 2, 3);
surf(Ds, Ws, ls);
hold on;
[C, h] = contour3(Ds, Ws, ls, 10.^-(1:6), '-k');
set(h, 'LineWidth', 2);
hold off;
set(gca, 'Zscale', 'log');
set(gca, 'ZLim', [1e-10, 1e0]);
view(-50, 30);
xlabel('D');
ylabel('W');
zlabel('L');
title({'Directing a Gaussian beam of radius W onto a circular aperture of radius 1, what fraction', 'L = 1 - P_d/P_c of the transmitted power is lost if the beam is displaced from the center by D?', '(logarithmic scale with contours)'});

figure(23);
%subplot(2, 2, [2, 4]);
contour(Ds, Ws, log10(max(ls, realmin)), kron(-(1:6), [1, 1]) + kron(ones(1, 6), log10([2, 5])), 'Color', [.8, .8, .8], 'LineWidth', 0.2835);
hold on;
contour(Ds, Ws, log10(max(ls, realmin)), -(1:6), '-k', 'ShowText', 'on', 'LineWidth', 0.8504);
hold off;
set(gca, 'XLim', [0, max(Ds)]);
set(gca, 'YLim', [0, max(Ws)]);
xlabel('D');
ylabel('W');
text(.7, 1, 'log_{10}(1 - P_d/P_c)');
title({'Directing a Gaussian beam of radius W onto a circular aperture of radius 1, what fraction', 'L = 1 - P_d/P_c of the transmitted power is lost if the beam is displaced from the center by D?', '(contours only)'});
grid on;